<id>
din1031:ssikarma
</id>

<version>
1.0.2
</version>

<edit file>
$boarddir/SSI.php
</edit file>

<search for>
function ssi_topTopicsViews($num_topics = 10, $output_method = 'echo')
{
	return ssi_topTopics('views', $num_topics, $output_method);
}
</search for>

<replace>
function ssi_topTopicsViews($num_topics = 10, $output_method = 'echo')
{
	return ssi_topTopics('views', $num_topics, $output_method);
}

/*
Master SSI Function for karma, easier is to use ssi_karmaHighest and ssi_karmaLowest
$type 'good' or 'bad', standard is good =P
Normal calculate everytime the total which callculated karmaGood - karmaBad, 
but if you only like to have the highest postitve karma than set this option to false.
Example what is the diffrent
3 user with +14/-10, +20/-10, +12/-0
will be sorted by the $onlyTotal true like -> +12/0, +20/-10, +14/-10 <- because the first 
have total of 12. If you set it to false it will be look like this -> +20/-10, +14/-10, +12/0 
because +20 is the highest. Hope it's clear, ahh i forgot the total thing work only on 
positive/negativ karma count if you use standard it will callcualte evertime ;D.
*/
function ssi_karma($type = 'good', $topMembers = 5, $onlyTotal = true, $output_method = 'echo')
{
	global $db_prefix, $scripturl, $modSettings, $context;
	
	// If the mod is disabled, do nothing.
	if (empty($modSettings['karmaMode']))
		return ($output_method != 'echo' ? array() : '');
	
	//Fixes :)
	$topMembers = (int) $topMembers;
	$topMembers = empty($topMembers) || $topMembers < 0 ? 5 : $topMembers;
	$onlyTotal = !is_bool($onlyTotal) ? true : $onlyTotal;

	//Speed it up a little :) if the user count is lower than topMembers than use this :)
	$topMembers = $context['common_stats']['total_members'] <= $topMembers ? $context['common_stats']['total_members'] : $topMembers;

	//Select the correct sql for the select you made :)
	if($modSettings['karmaMode'] == '1' || $onlyTotal)
		$sql = "FLOOR(1000000+karmaGood-karmaBad)"; //It look strange... but there is small bug in SQL on negativ results...
	else 
		$sql = "karmaGood";
	
	//Load the Karma Good Data
	$results = db_query("
		SELECT realName, karmaGood, karmaBad, ID_MEMBER 
		FROM {$db_prefix}members 
		ORDER BY $sql ".($type != 'good' ? 'ASC' : 'DESC')."
		LIMIT $topMembers", __FILE__, __LINE__);
		
	$return = array();
	$colorids = array();
	
	while($row = mysql_fetch_assoc($results)) {
		$return[] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'karmaGood' => $row['karmaGood'],
			'karmaBad' => $row['karmaBad'],
			'karmaTotal' => $row['karmaGood'] - $row['karmaBad'],
		);
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}	
	mysql_free_result($results);
	
	//Add colors only on installed SSI Member Color Link
	if(function_exists('ssi_loadColors') && !empty($colorids)) {
		global $color_profile;
		ssi_loadColors($colorids);
		foreach($return as $k => $p) {
			$profile = $color_profile[$p['id']];
			if(!empty($profile)) {
				$return[$k]['link'] = $profile['link'];
			}
		}
	}
	
	//Output?
	if($output_method != 'echo')
		return $return;
	
	//Okay some output =)
	if(empty($return))
		return;

	echo '
		<table class="ssi_table">';
	foreach ($return as $temp) {
		echo '
			<tr>
				<td align="right">
					', $temp['link'], '
				</td>';
		if ($modSettings['karmaMode'] == '1')
			echo '
				<td align="left">', $modSettings['karmaLabel'], ' ', $temp['karmaTotal'], '</td>';
		else
			echo '
				<td align="left">', $modSettings['karmaLabel'], ' +', $temp['karmaGood'], '/-', $temp['karmaBad'], ($onlyTotal ? ' ('.$temp['karmaTotal'].')' : ''), '</td>';
		echo'
			</tr>';
	}
	echo '
		</table>';	
}

//Show user with highest karma, Discription for onlyTotal see ssi_karma
function ssi_karmaHighest($topMembers = 5, $onlyTotal = true, $output_method = 'echo') 
{
	return ssi_karma('good', $topMembers, $onlyTotal, $output_method);
}

//Show user with lowest karma, Discription for onlyTotal see ssi_karma
function ssi_karmaLowest($topMembers = 5, $onlyTotal = true, $output_method = 'echo') 
{
	return ssi_karma('bad', $topMembers, $onlyTotal, $output_method);
}
</replace>

<edit file>
$boarddir/ssi_examples.php
</edit file>

<search for>
			<h3>Top Topics by View Function: &lt;?php ssi_topTopicsViews(); ?&gt;</h3>
</search for>

<replace>
			<h3>Highest Karma Function: &lt;?php ssi_karmaHighest(); ?&gt;</h3>
			<?php ssi_karmaHighest(); flush(); ?>

		<hr />

			<h3>Lowest Karma Function Function: &lt;?php ssi_karmaLowest(); ?&gt;</h3>
			<?php ssi_karmaLowest(); flush(); ?>

		<hr />

			<h3>Top Topics by View Function: &lt;?php ssi_topTopicsViews(); ?&gt;</h3>
</replace>
